Index: waeup/trunk/src/waeup/university/certificate.py
===================================================================
--- waeup/trunk/src/waeup/university/certificate.py	(revision 3551)
+++ waeup/trunk/src/waeup/university/certificate.py	(revision 4789)
@@ -0,0 +1,144 @@
+"""WAeUP portal certificates
+"""
+import grok
+from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
+from zope.app.catalog.interfaces import ICatalog
+from zope.component import getUtility
+from zope.component.interfaces import IFactory, ComponentLookupError
+from zope.interface import implementedBy
+from waeup.interfaces import ICertificate, ICertificateCourse, ICourse
+
+class Certificate(grok.Container):
+    """A certificate.
+    """
+    grok.implements(ICertificate)
+
+    def __init__(self, code=u'NA', title=u'Unnamed Certificate',
+                 category=None, study_mode=None, start_level=None,
+                 end_level=None, application_category=None, m_prefix=u'',
+                 max_pass = u''):
+        super(Certificate, self).__init__()
+        self.code = code
+        self.title = title
+        self.category = category
+        self.study_mode = study_mode
+        self.start_level = start_level
+        self.end_level = end_level
+        self.application_category = application_category
+        self.m_prefix = m_prefix
+        self.max_pass = max_pass
+        # Initialize workflow state...
+        self.setReviewState('unchecked')
+
+    def check(self):
+        """Set Review State to ``checked``.
+        """
+        self.setReviewState(state='checked')
+
+    def getReviewState(self):
+        return IWorkflowState(self).getState()
+
+    def setReviewState(self, state=None):
+        """Try to set new state.
+
+        Instead of simply setting a value, we fire a transition of a
+        workflow. This might fail if, for instance, the required state
+        is not part of the workflow or unreachable from current state.
+        """
+        if state == self.getReviewState():
+            # Accept staying in the same state, even if workflow does
+            # not allow this.
+            return
+        info = IWorkflowInfo(self)
+        info.fireTransitionToward(state)
+        return
+
+    review_state = property(getReviewState, setReviewState)
+    
+    def addCourseRef(self, course, level=100, core_or_elective=True):
+        """Add a course reference.
+        """
+        code = "%s_%s" % (course.code, level)
+        self[code] = CertificateCourse(course, level, core_or_elective)
+        self[code].__parent__ = self
+        self[code].__name__ = code
+        self._p_changed = True
+
+    def delCourseRef(self, code, level=None):
+        """Delete a course denoted by its code.
+        """
+        for key in self.keys():
+            if self[key].getCourseCode() != code:
+                continue
+            if level is not None and str(self[key].level) != str(level):
+                # found a course with correct key but wrong level...
+                continue
+            del self[key]
+            self._p_changed = True
+        return
+
+
+
+
+class CertificateFactory(grok.GlobalUtility):
+    """A factory for certificates.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.Certificate')
+    title = u"Create a new certificate.",
+    description = u"This factory instantiates new certificate instances."
+
+    def __call__(self, *args, **kw):
+        return Certificate(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(Certificate)
+
+class CertificateCourse(grok.Model):
+    grok.implements(ICertificateCourse)
+
+    def __init__(self, course=None, level=100, core_or_elective=True):
+        self.course = course
+        self.level = level
+        self.core_or_elective = core_or_elective
+
+    def getCourseCode(self):
+        """Get code of a course.
+        """
+        return self.course.code
+    
+class CertificateCourseFactory(grok.GlobalUtility):
+    """A factory for certificate courses.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.CertificateCourse')
+    title = u"Create a new certificate course.",
+    description = u"This factory instantiates new certificate courses."
+
+    def __call__(self, *args, **kw):
+        return CertificateCourse(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(CertificateCourse)
+
+@grok.subscribe(ICourse, grok.IObjectRemovedEvent)
+def removedCourseHandler(course, event):
+    """If a course is deleted, we make sure that also references in a
+       certificatecontainer are removed.
+    """
+    code = course.code
+
+    # Find all certcourses that reference the given course...
+    try:
+        cat = getUtility(ICatalog, name='certcourses_catalog')
+    except ComponentLookupError:
+        # catalog not available. This might happen during tests.
+        return
+        
+    results = cat.searchResults(course_code=(code, code))
+    for certcourse in results:
+        # Remove that reference...
+        cert = certcourse.__parent__
+        cert.delCourseRef(code)
+        cert._p_changed = True
+    return
Index: waeup/trunk/src/waeup/university/certificatecontainer.py
===================================================================
--- waeup/trunk/src/waeup/university/certificatecontainer.py	(revision 4789)
+++ waeup/trunk/src/waeup/university/certificatecontainer.py	(revision 4789)
@@ -0,0 +1,38 @@
+"""Containers for certificates.
+"""
+import grok
+from waeup.interfaces import ICertificateContainer, ICertificate
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+
+class CertificateContainer(grok.Container):
+    """See interfaces for description.
+    """
+    grok.implements(ICertificateContainer)
+    grok.require('waeup.manageUniversity')
+
+    def addCertificate(self, certificate):
+        if not ICertificate.providedBy(certificate):
+            raise TypeError('CertificateContainers contain only '
+                            'ICertificate instances')
+        self[certificate.code] = certificate
+        return
+
+    def clear(self):
+        keys = self.keys()
+        for key in keys:
+            del self[key]
+
+class CertificateContainerFactory(grok.GlobalUtility):
+    """A factory for certificate containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.CertificateContainer')
+    title = u"Create a new certificate container.",
+    description = u"This factory instantiates new certificate containers."
+
+    def __call__(self, *args, **kw):
+        return CertificateContainer(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(CertificateContainer)
Index: waeup/trunk/src/waeup/university/course.py
===================================================================
--- waeup/trunk/src/waeup/university/course.py	(revision 3551)
+++ waeup/trunk/src/waeup/university/course.py	(revision 4789)
@@ -0,0 +1,40 @@
+"""Courses.
+"""
+import grok
+from zope.interface import implementedBy
+from zope.component.interfaces import IFactory
+from waeup.interfaces import ICourse
+
+class Course(grok.Model):
+    """A university course.
+    """
+    grok.implements(ICourse)
+
+    def __init__(self,
+                 title=u'Unnamed Course',
+                 code=u'NA',
+                 level=None,
+                 credits=0,
+                 passmark=40,
+                 semester=1, **kw):
+        super(Course, self).__init__(**kw)
+        self.title = title
+        self.code = code
+        self.level = level
+        self.credits = credits
+        self.passmark = passmark
+        self.semester = semester
+        
+class CourseFactory(grok.GlobalUtility):
+    """A factory for courses.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.Course')
+    title = u"Create a new course.",
+    description = u"This factory instantiates new course instances."
+
+    def __call__(self, *args, **kw):
+        return Course(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(Course)
Index: waeup/trunk/src/waeup/university/coursecontainer.py
===================================================================
--- waeup/trunk/src/waeup/university/coursecontainer.py	(revision 4789)
+++ waeup/trunk/src/waeup/university/coursecontainer.py	(revision 4789)
@@ -0,0 +1,41 @@
+"""Course containers.
+"""
+import grok
+from zope.interface import implementedBy
+from zope.component.interfaces import IFactory
+from waeup.interfaces import ICourseContainer, ICourse
+
+class CourseContainer(grok.Container):
+    """See interfaces for description.
+    """
+    grok.implements(ICourseContainer)
+    grok.require('waeup.manageUniversity')
+
+    def addCourse(self, course):
+        """Add a course.
+        """
+        if not ICourse.providedBy(course):
+            raise TypeError('CourseContainers contain only ICourse instances')
+        self[course.code] = course
+        return
+
+    def clear(self):
+        """Remove all objects from course container.
+        """
+        keys = self.keys()
+        for key in keys:
+            del self[key]
+
+class CourseContainerFactory(grok.GlobalUtility):
+    """A factory for course containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.CourseContainer')
+    title = u"Create a new course container.",
+    description = u"This factory instantiates new course containers."
+
+    def __call__(self, *args, **kw):
+        return CourseContainer(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(CourseContainer)
Index: waeup/trunk/src/waeup/university/department.py
===================================================================
--- waeup/trunk/src/waeup/university/department.py	(revision 3551)
+++ waeup/trunk/src/waeup/university/department.py	(revision 4789)
@@ -0,0 +1,57 @@
+"""University departments.
+"""
+import grok
+from zope.component import createObject
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.interfaces import IDepartment
+
+class Department(grok.Container):
+    """A university department.
+    """
+    grok.implements(IDepartment)
+
+    # A simple counter for ids.
+    next_id = 0L
+    
+    def __init__(self,
+                 title=u'Unnamed Department',
+                 title_prefix=u'department',
+                 code=u"NA", **kw):
+        super(Department, self).__init__(**kw)
+        self.title = title
+        self.title_prefix = title_prefix
+        self.code = code
+        self.courses = createObject(u'waeup.CourseContainer')
+        self.courses.__parent__ = self
+        self.courses.__name__ = 'courses'
+        self.certificates = createObject(u'waeup.CertificateContainer')
+        self.certificates.__parent__ = self
+        self.certificates.__name__ = 'certificates'
+
+    def traverse(self, name):
+        """Deliver appropriate containers, if someone wants to go to courses
+        or departments.
+        """
+        if name == 'courses':
+            return self.courses
+        elif name == 'certificates':
+            return self.certificates
+        return None
+        
+
+class DepartmentFactory(grok.GlobalUtility):
+    """A factory for department containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.Department')
+    title = u"Create a new department.",
+    description = u"This factory instantiates new department instances."
+
+    def __call__(self, *args, **kw):
+        return Department(*args, **kw)
+
+    def getInterfaces(self):
+        """Get interfaces of objects provided by this factory.
+        """
+        return implementedBy(Department)
Index: waeup/trunk/src/waeup/university/faculty.py
===================================================================
--- waeup/trunk/src/waeup/university/faculty.py	(revision 3551)
+++ waeup/trunk/src/waeup/university/faculty.py	(revision 4789)
@@ -1,15 +1,59 @@
+"""Faculty components.
+"""
+
 import grok
-from waeup.basecontainer import BaseContainer
-from interfaces import IFaculty
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.interfaces import IFaculty, IDepartment
 
-class Faculty(BaseContainer):
+class Faculty(grok.Container):
+    """A university faculty.
+    """
     grok.implements(IFaculty)
 
-    def __init__(self, name=u'Unnamed Faculty', **kw):
+    def __init__(self,
+                 title=u'Unnamed Faculty',
+                 title_prefix=u'faculty',
+                 code=u'NA', **kw):
         super(Faculty, self).__init__(**kw)
-        self.name = name
+        self.title = title
+        self.title_prefix = title_prefix
+        self.code = code
 
-class Index(grok.DisplayForm):
-    form_fields = grok.AutoFields(IFaculty)
+    def addDepartment(self, department):
+        """Add a department to the faculty.
+        """
+        if not IDepartment.providedBy(department):
+            raise TypeError('Faculties contain only IDepartment instances')
+        self[department.code] = department
 
+    def clear(self):
+        """Remove all departments from faculty.
+        """
+        keys = self.keys()
+        for key in keys:
+            del self[key]
 
+    def getName(self, key):
+        """Get complete faculty name.
+        """
+        if key in self.keys():
+            dept = self[key]
+            prefix = dept.title_prefix
+            prefix = prefix[0].upper() + prefix[1:]
+            return '%s of %s' % (prefix, dept.title)
+
+        
+class FacultyFactory(grok.GlobalUtility):
+    """A factory for faculty containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.Faculty')
+    title = u"Create a new faculty.",
+    description = u"This factory instantiates new faculty instances."
+
+    def __call__(self, *args, **kw):
+        return Faculty()
+
+    def getInterfaces(self):
+        return implementedBy(Faculty)
Index: waeup/trunk/src/waeup/university/facultycontainer.py
===================================================================
--- waeup/trunk/src/waeup/university/facultycontainer.py	(revision 3551)
+++ waeup/trunk/src/waeup/university/facultycontainer.py	(revision 4789)
@@ -1,9 +1,42 @@
 import grok
-from waeup.basecontainer import BaseContainer
-from interfaces import IFaculty
-from faculty import Faculty
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.interfaces import IFacultyContainer, IFaculty
 
-class FacultyContainer(BaseContainer):
-    
-    name = u'Faculties'
-    childClass = Faculty
+class FacultyContainer(grok.Container):
+    """See interfaces for description.
+    """
+    grok.implements(IFacultyContainer)
+    grok.require('waeup.manageUniversity')
+
+    def addFaculty(self, faculty):
+        if not IFaculty.providedBy(faculty):
+            raise TypeError('FacultyContainers contain only IFaculty instances')
+        self[faculty.code] = faculty
+        return
+
+    def clear(self):
+        keys = self.keys()
+        for key in keys:
+            del self[key]
+
+    def getName(self, key):
+        if key in self.keys():
+            fac = self[key]
+            prefix = fac.title_prefix
+            prefix = prefix[0].upper() + prefix[1:]
+            return '%s of %s' % (prefix, fac.title)
+            
+class FacultyContainerFactory(grok.GlobalUtility):
+    """A factory for faculty containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.FacultyContainer')
+    title = u"Create a new faculty container.",
+    description = u"This factory instantiates new faculty containers."
+
+    def __call__(self):
+        return FacultyContainer()
+
+    def getInterfaces(self):
+        return implementedBy(FacultyContainer)
Index: waeup/trunk/src/waeup/users.py
===================================================================
--- waeup/trunk/src/waeup/users.py	(revision 4789)
+++ waeup/trunk/src/waeup/users.py	(revision 4789)
@@ -0,0 +1,35 @@
+"""Users (principals) for the WAeUP portal.
+"""
+import grok
+from waeup.authentication import Account
+from waeup.interfaces import IUserContainer
+
+class UserContainer(grok.Container):
+    """A container for principals.
+
+    See interfaces.py and users.txt for extensive description.
+    """
+    grok.implements(IUserContainer)
+    grok.require('waeup.manageUsers')
+
+    def addUser(self, name, password, title=None, description=None, roles=[]):
+        """Add a new Account instance, created from parameters.
+        """
+        if title is None:
+            title = name
+        if description is None:
+            description = title
+        self[name] = Account(name, password, title, description, roles)
+
+    def addAccount(self, account):
+        """Add the account passed.
+        """
+        self[account.name] = account
+        
+    def delUser(self, name):
+        """Delete user, if an account with the given name exists.
+
+        Do not complain, if the name does not exist.
+        """
+        if name in self.keys():
+            del self[name]
Index: waeup/trunk/src/waeup/utils/csvimport.py
===================================================================
--- waeup/trunk/src/waeup/utils/csvimport.py	(revision 4789)
+++ waeup/trunk/src/waeup/utils/csvimport.py	(revision 4789)
@@ -0,0 +1,246 @@
+"""CSV importers.
+"""
+import grok
+from waeup.csvfile import CSVFile, toBool
+from waeup.csvfile.interfaces import ICSVFile
+from waeup.interfaces import IFacultyContainer, IWAeUPCSVImporter
+from waeup.utils.importexport import CSVImporter
+from zope.app.catalog.interfaces import ICatalog
+from zope.component import createObject, getUtility
+
+#
+# CSV import stuff
+#
+class IFacultyCSVFile(ICSVFile):
+    """A CSV file that contains faculty data.
+    """
+
+class FacultyCSVFile(CSVFile):
+    """An abstraction of a CSV file containing faculties.
+    """
+    grok.implements(IFacultyCSVFile)
+    grok.provides(IFacultyCSVFile)
+    required_fields = ['code', 'title', 'title_prefix']
+
+class FacultyCSVImporter(CSVImporter):
+    """Shuffle data from faculty CSV files into faculty containers.
+    """
+    # Tell, what kinds of objects we connect...
+    grok.adapts(IFacultyCSVFile, IFacultyContainer)
+    # Tell the world, that we are an importer...
+    grok.implements(IWAeUPCSVImporter)
+    grok.provides(IWAeUPCSVImporter)
+
+    datatype = u'Faculty Importer'
+
+    def doImport(self, clear_old_data=True, overwrite=True):
+        # CSVImporter instances have a `csvfile` and a `receiver`
+        # object defined which refer to the CSV file and the container.
+        for row in self.csvfile.getData():
+            new_item = createObject(u'waeup.Faculty')
+            for key, val in row.items():
+                setattr(new_item, key, val)
+            self.receiver.addFaculty(new_item)
+        return
+
+class IDepartmentCSVFile(ICSVFile):
+    """A CSV file that contains department data.
+    """
+
+class DepartmentCSVFile(CSVFile):
+    """An abstraction of a CSV file containing departments.
+    """
+    grok.implements(IDepartmentCSVFile)
+    grok.provides(IDepartmentCSVFile)
+    required_fields = ['code', 'title', 'title_prefix', 'faculty_code']
+
+class DepartmentCSVImporter(CSVImporter):
+    """Shuffle data from department CSV files into faculty containers.
+    """
+    # Tell, what kinds of objects we connect...
+    grok.adapts(IDepartmentCSVFile, IFacultyContainer)
+    # Tell the world, that we are an importer...
+    grok.implements(IWAeUPCSVImporter)
+    grok.provides(IWAeUPCSVImporter)
+
+    datatype = u'Department Importer'
+
+    def doImport(self, clear_old_data=True, overwrite=True):
+        # CSVImporter instances have a `csvfile` and a `receiver`
+        # object defined which refer to the CSV file and the container.
+        for row in self.csvfile.getData():
+            new_item = createObject(u'waeup.Department')
+            faculty_code = row['faculty_code']
+            faculty = self.receiver[faculty_code]
+            del row['faculty_code']
+            for key, val in row.items():
+                setattr(new_item, key, val)
+            faculty.addDepartment(new_item)
+        return
+
+class ICourseCSVFile(ICSVFile):
+    """A CSV file that contains course data.
+    """
+
+class CourseCSVFile(CSVFile):
+    """An abstraction of a CSV file containing courses.
+    """
+    grok.implements(ICourseCSVFile)
+    grok.provides(ICourseCSVFile)
+    required_fields = ['code', 'title', 'level', 'passmark', 'credits',
+                       'semester', 'faculty', 'department']
+
+class CourseCSVImporter(CSVImporter):
+    """Shuffle data from course CSV files into faculty containers.
+    """
+    # Tell, what kinds of objects we connect...
+    grok.adapts(ICourseCSVFile, IFacultyContainer)
+    # Tell the world, that we are an importer...
+    grok.implements(IWAeUPCSVImporter)
+    grok.provides(IWAeUPCSVImporter)
+
+    datatype = u'Course Importer'
+
+    def doImport(self, clear_old_data=True, overwrite=True):
+        # CSVImporter instances have a `csvfile` and a `receiver`
+        # object defined which refer to the CSV file and the container.
+        for row in self.csvfile.getData():
+
+            new_item = createObject(u'waeup.Course')
+            
+            faculty_code = row['faculty']
+            faculty = self.receiver[faculty_code]
+            del row['faculty']
+
+            dept_code = row['department']
+            dept = faculty[dept_code]
+            del row['department']
+
+            # Type casts...
+            if row['semester'] == '' or row['semester'] == 'None':
+                    row['semester'] = 0
+            if row['semester'] == '1,2':
+                row['semester'] = 3
+            for key in ['semester', 'credits', 'passmark']:
+                if row[key] == '' or row[key] == 'None':
+                    row[key] = None
+                    continue
+                row[key] = int(row[key])
+
+            for key, val in row.items():
+                setattr(new_item, key, val)
+            dept.courses.addCourse(new_item)
+        return
+
+class ICertificateCSVFile(ICSVFile):
+    """A CSV file that contains certificate data.
+    """
+
+class CertificateCSVFile(CSVFile):
+    """An abstraction of a CSV file containing certificates.
+    """
+    grok.implements(ICertificateCSVFile)
+    grok.provides(ICertificateCSVFile)
+    required_fields = ['code', 'title', 'faculty_code', 'department_code',
+                       'category', 'study_mode', 'start_level', 'end_level',
+                       'm_prefix', 'max_pass', 'application_category']
+
+class CertificateCSVImporter(CSVImporter):
+    """Shuffle data from certificate CSV files into faculty containers.
+    """
+    # Tell, what kinds of objects we connect...
+    grok.adapts(ICertificateCSVFile, IFacultyContainer)
+    # Tell the world, that we are an importer...
+    grok.implements(IWAeUPCSVImporter)
+    grok.provides(IWAeUPCSVImporter)
+
+    datatype = u'Certificate Importer'
+
+    def doImport(self, clear_old_data=True, overwrite=True):
+        # CSVImporter instances have a `csvfile` and a `receiver`
+        # object defined which refer to the CSV file and the container.
+        for row in self.csvfile.getData():
+
+            new_item = createObject(u'waeup.Certificate')
+            
+            faculty_code = row['faculty_code']
+            faculty = self.receiver[faculty_code]
+            del row['faculty_code']
+
+            dept_code = row['department_code']
+            dept = faculty[dept_code]
+            del row['department_code']
+
+            for key, val in row.items():
+                setattr(new_item, key, val)
+            dept.certificates.addCertificate(new_item)
+        return
+
+class ICertificateCourseCSVFile(ICSVFile):
+    """A CSV file that contains certificate-course data.
+    """
+
+class CertificateCourseCSVFile(CSVFile):
+    """An abstraction of a CSV file containing certificate-courses.
+    """
+    grok.implements(ICertificateCourseCSVFile)
+    grok.provides(ICertificateCourseCSVFile)
+    required_fields = ['code', 'faculty_code', 'department_code',
+                       'certificate_code', 'level', 'core_or_elective']
+
+class CertificateCourseCSVImporter(CSVImporter):
+    """Shuffle data from certificate CSV files into faculty containers.
+    """
+    # Tell, what kinds of objects we connect...
+    grok.adapts(ICertificateCourseCSVFile, IFacultyContainer)
+    # Tell the world, that we are an importer...
+    grok.implements(IWAeUPCSVImporter)
+    grok.provides(IWAeUPCSVImporter)
+
+    datatype = u'Certificate Course Importer'
+
+    def doImport(self, clear_old_data=True, overwrite=True):
+        # CSVImporter instances have a `csvfile` and a `receiver`
+        # object defined which refer to the CSV file and the container.
+        for row in self.csvfile.getData():
+            new_item = createObject(u'waeup.CertificateCourse')
+            code = row['code']
+            del row['code']
+            
+            faculty_code = row['faculty_code']
+            faculty = self.receiver[faculty_code]
+            del row['faculty_code']
+
+            dept_code = row['department_code']
+            dept = faculty[dept_code]
+            del row['department_code']
+
+            cert_code = row['certificate_code']
+            cert = dept.certificates[cert_code]
+            del row['certificate_code']
+
+            course = self.getCourse(code)
+            
+            # Type casts...
+            row['core_or_elective'] = toBool(row['core_or_elective'])
+            row['level'] = int(row['level'])
+            
+            cert.addCourseRef(course, **row)
+        return
+
+    def getCourse(self, code):
+        """Get the course with code `code`.
+
+        Courses can be anywhere in the site. Therefore we ask the
+        catalog.
+        """
+        cat = getUtility(ICatalog, name='courses_catalog')
+        result = cat.searchResults(code=(code, code))
+        if len(result) < 1:
+            raise KeyError('No such course found: %s' % code)
+
+        # We might get more than one result, but this should not
+        # happen, as course codes are supposed to be unique.
+        return list(result)[0]
+
+        
Index: waeup/trunk/src/waeup/utils/helpers.py
===================================================================
--- waeup/trunk/src/waeup/utils/helpers.py	(revision 4789)
+++ waeup/trunk/src/waeup/utils/helpers.py	(revision 4789)
@@ -0,0 +1,97 @@
+"""General helper functions for WAeUP.
+"""
+import os
+import re
+import sys
+import shutil
+
+def removeFileOrDirectory(filepath):
+    """Remove a file or directory.
+    """
+    filepath = os.path.abspath(filepath)
+    if not os.path.exists(filepath):
+        return
+    if os.path.isdir(filepath):
+        shutil.rmtree(filepath)
+    else:
+        os.unlink(filepath)
+    return
+
+def copyFileSystemTree(src, dst, overwrite=False, del_old=False):
+    """Copy contents of directory src to directory dst.
+
+    Both directories must exists.
+
+    If `overwrite` is true, any same named objects will be
+    overwritten. Otherwise these files will not be touched.
+
+    If `del_old` is true, copied files and directories will be removed
+    from the src directory.
+
+    This functions returns a list of non-copied files.
+
+    Unix hidden files and directories (starting with '.') are not
+    processed by this function.
+    """
+    if not os.path.exists(src):
+        raise ValueError('source path does not exist: %s' % src)
+    if not os.path.exists(dst):
+        raise ValueError('destination path does not exist: %s' % dst)
+    if not os.path.isdir(src):
+        raise ValueError('source path is not a directory: %s' % src)
+    if not os.path.isdir(dst):
+        raise ValueError('destination path is not a directory: %s' % dst)
+    not_copied = []
+    for item in os.listdir(src):
+        if item.startswith('.'):
+            continue # We do not copy hidden stuff...
+        itemsrc = os.path.join(src, item)
+        itemdst = os.path.join(dst, item)
+
+        if os.path.exists(itemdst):
+            if overwrite is True:
+                removeFileOrDirectory(itemdst)
+            else:
+                not_copied.append(item)
+                continue
+        
+        if os.path.isdir(itemsrc):
+            shutil.copytree(itemsrc, itemdst)
+        else:
+            shutil.copy2(itemsrc, itemdst)
+        if del_old:
+            removeFileOrDirectory(itemsrc)
+    return not_copied
+
+
+def getInnerHTMLPart(html_code):
+    """Return the 'inner' part of a complete HTML snippet.
+
+    If there is a form part, get this.
+
+    If there is no form part, try to return the body part contents.
+
+    If there is no body, return as-is.
+    """
+
+    try:
+        result = re.match('^.+(<forms[^\>]*>.*</form>).+$', html_code,
+                          re.DOTALL).groups()[0]
+        return result
+    except AttributeError:
+        # No <form> part included
+        try:
+            result = re.match('^.+<body[^\>]*>(.*)</body>.*$', html_code,
+                              re.DOTALL).groups()[0]
+            return result
+        except AttributeError:
+            # No <form> and no <body> tag...
+            pass
+    return html_code
+
+def getName(context):
+    """Construct a name out of an object with prefix and title.
+    """
+    prefix = context.title_prefix
+    prefix = prefix[0].upper() + prefix[1:]
+    return '%s of %s' % (prefix, context.title)
